package web

import (
	"net/http"

	"github.com/gin-contrib/sessions"
	"github.com/gin-gonic/gin"

	"code.osinet.fr/fgm/sqs_demo/back/services/redriver"
)

func makeDeleteHandler(rd redriver.Redriver) gin.HandlerFunc {
	return func(c *gin.Context) {
		qName := c.Param("name")

		sess := sessions.Default(c)
		flashes := sess.Flashes()
		sess.Clear()
		sess.Save()

		c.HTML(http.StatusOK, "confirm", gin.H{
			"flashes":     flashes,
			"question":    "Do you confirm this deletion request ?",
			"description": "The message cannot be recovered after that step",
			"cancel":      "Cancel",
			"confirm":     "Delete",
			"redirect":    "/queue/" + qName,
		})
	}
	return nil
}

func makeDeleteConfirmHandler(rd redriver.Redriver) gin.HandlerFunc {
	return func(c *gin.Context) {
		c.JSON(http.StatusServiceUnavailable, gin.H{
			"message": "deletion confirmation",
			"error":   "not implemented",
		})
	}
}
